static void npf_copy_page(void *to, void *from) {
	int i, d1;
        char fpu_save[108];

	for (i=4096-256;i>=0;i-=256)
		__asm__ __volatile(
		"	movl	192(%1,%2),%0\n"
		"	movl	128(%1,%2),%0\n"
		"	movl	64(%1,%2),%0\n"
		"	movl	0(%1,%2),%0\n"
		: "=&r" (d1)
		: "r" (from), "r" (i)
		);
        __asm__ __volatile__ (
		"	fsave	%0\n"
		"	fwait\n"
		: "=m"(fpu_save[0])
	);

	for(i=0; i<4096/64; i++) {
		__asm__ __volatile__ (
		"	movq	(%0), %%mm0\n"
		"	movntq	%%mm0, (%1)\n"
		"	movq	8(%0), %%mm1\n"
		"	movntq	%%mm1, 8(%1)\n"
		"	movq	16(%0), %%mm2\n"
		"	movntq	%%mm2, 16(%1)\n"
		"	movq	24(%0), %%mm3\n"
		"	movntq	%%mm3, 24(%1)\n"
		"	movq	32(%0), %%mm4\n"
		"	movntq	%%mm4, 32(%1)\n"
		"	movq	40(%0), %%mm5\n"
		"	movntq	%%mm5, 40(%1)\n"
		"	movq	48(%0), %%mm6\n"
		"	movntq	%%mm6, 48(%1)\n"
		"	movq	56(%0), %%mm7\n"
		"	movntq	%%mm7, 56(%1)\n"
		: : "r" (from), "r" (to) : "memory"
		);
		from+=64;
		to+=64;
	}
	__asm__ __volatile__ (
		"	sfence\n"
			FEMMS
		"	frstor	%0\n"
		: : "m"(fpu_save[0])
	);
}
